Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 3211)
@@ -19,5 +19,5 @@
    !!--------------------------------------------------------------------
    USE dom_oce         ! ocean space and time domain
-   USE lbclnk          ! lateal boundary condition / mpp exchanges
+   USE lbclnk          ! lateral boundary condition / mpp exchanges
    USE iom_def         ! iom variables definitions
    USE iom_ioipsl      ! NetCDF format with IOIPSL library
@@ -34,4 +34,5 @@
    USE mod_attribut
 # endif
+   USE zpermute, ONLY : permute_z_last   ! Re-order a 3d array back to external (z-last) ordering
 
    IMPLICIT NONE
@@ -70,4 +71,7 @@
    END INTERFACE
 # endif
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -540,5 +544,5 @@
       INTEGER                        ::   ix1, ix2, iy1, iy2   ! subdomain indexes
       INTEGER                        ::   ji, jj      ! loop counters
-      INTEGER                        ::   irankpv       ! 
+      INTEGER                        ::   irankpv     ! 
       INTEGER                        ::   ind1, ind2  ! substring index
       INTEGER, DIMENSION(jpmax_dims) ::   istart      ! starting point to read for each axis
@@ -551,4 +555,13 @@
       CHARACTER(LEN=100)             ::   clname      ! file name
       CHARACTER(LEN=1)               ::   clrankpv, cldmspc      ! 
+
+#if defined key_z_first
+      !! DCSE_NEMO: need a work array to match layout on disk, which is always z-last
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   wpv_r3d         ! copy of pv_r3d with dimensions permuted
+      INTEGER                                 ::   istat_wpv_r3d   ! result of attempt to allocate the above
+      INTEGER, DIMENSION(3)                   ::   ishape_pv_r3d   ! size of the dimensions of pv_r3d
+      INTEGER                                 ::   jk              ! loop counter
+#endif
+
       !---------------------------------------------------------------------
       !
@@ -670,10 +683,34 @@
          END DO
 
+#if defined key_z_first
+         !! DCSE_NEMO: Allocate 3d work-array with z-index last
+         !!            to match layout on disk
+         IF (PRESENT(pv_r3d)) THEN
+            ishape_pv_r3d = SHAPE(pv_r3d)
+            IF (ishape_pv_r3d(1) /= jpk) THEN
+               WRITE( ctmp1, FMT="('leading dimension is ',i5,', not ',i5,' (jpk) as expected')" ) &
+                  &  ishape_pv_r3d(1), jpk
+               CALL ctl_warn( trim(clinfo), 'beware: possible problem with 3d array, ', ctmp1 ) 
+            ENDIF
+            ALLOCATE(wpv_r3d(ishape_pv_r3d(2),ishape_pv_r3d(3),ishape_pv_r3d(1)),STAT=istat_wpv_r3d)
+            IF (istat_wpv_r3d /= 0) THEN
+               CALL ctl_stop( trim(clinfo), 'failed to allocate wpv_r3d' )
+            ENDIF
+         ENDIF
+#endif
+
          ! check that icnt matches the input array
          !-     
+
+         !! DCSE_NEMO: beware! want ishape to match wpv_r3d, not pv_r3d
+
          IF( idom == jpdom_unknown ) THEN
             IF( irankpv == 1 )        ishape(1:1) = SHAPE(pv_r1d)
             IF( irankpv == 2 )        ishape(1:2) = SHAPE(pv_r2d)
+#if defined key_z_first
+            IF( irankpv == 3 )        ishape(1:3) = SHAPE(wpv_r3d)
+#else
             IF( irankpv == 3 )        ishape(1:3) = SHAPE(pv_r3d)
+#endif
             ctmp1 = 'd'
          ELSE
@@ -688,7 +725,21 @@
 ! JMM + SM: ugly patch before getting the new version of lib_mpp)
 !               ishape(1:3) = SHAPE(pv_r3d(nldi:nlei,nldj:nlej,:))   ;   ctmp1 = 'd(nldi:nlei,nldj:nlej,:)'
-               IF( llnoov ) THEN ; ishape(1:3)=SHAPE(pv_r3d(nldi:nlei,nldj:nlej,:)) ; ctmp1='d(nldi:nlei,nldj:nlej,:)'
-               ELSE              ; ishape(1:3)=SHAPE(pv_r3d(1   :nlci,1   :nlcj,:)) ; ctmp1='d(1:nlci,1:nlcj,:)'
+#if defined key_z_first
+               IF( llnoov ) THEN
+                  ishape(1:3)=SHAPE(wpv_r3d(nldi:nlei,nldj:nlej,:))
+                  ctmp1='d(nldi:nlei,nldj:nlej,:)'
+               ELSE
+                  ishape(1:3)=SHAPE(wpv_r3d(1   :nlci,1   :nlcj,:))
+                  ctmp1='d(1:nlci,1:nlcj,:)'
                ENDIF
+#else
+               IF( llnoov ) THEN
+                  ishape(1:3)=SHAPE(pv_r3d(nldi:nlei,nldj:nlej,:))
+                  ctmp1='d(nldi:nlei,nldj:nlej,:)'
+               ELSE
+                  ishape(1:3)=SHAPE(pv_r3d(1   :nlci,1   :nlcj,:))
+                  ctmp1='d(1:nlci,1:nlcj,:)'
+               ENDIF
+#endif
             ENDIF
          ENDIF
@@ -720,4 +771,28 @@
          ENDIF
       
+#if defined key_z_first
+         SELECT CASE (iom_file(kiomid)%iolib)
+         CASE (jpioipsl )
+            IF  (PRESENT(pv_r3d)) THEN
+               CALL iom_ioipsl_get(  kiomid, idvar, inbdim, istart, icnt, ix1, ix2, iy1, iy2, pv_r1d, pv_r2d, wpv_r3d )
+            ELSE
+               CALL iom_ioipsl_get(  kiomid, idvar, inbdim, istart, icnt, ix1, ix2, iy1, iy2, pv_r1d, pv_r2d )
+            ENDIF
+         CASE (jpnf90   )
+            IF (PRESENT(pv_r3d)) THEN
+               CALL iom_nf90_get(    kiomid, idvar, inbdim, istart, icnt, ix1, ix2, iy1, iy2, pv_r1d, pv_r2d, wpv_r3d )
+            ELSE
+               CALL iom_nf90_get(    kiomid, idvar, inbdim, istart, icnt, ix1, ix2, iy1, iy2, pv_r1d, pv_r2d )
+            ENDIF
+         CASE (jprstdimg)
+            IF (PRESENT(pv_r3d)) THEN
+               CALL iom_rstdimg_get( kiomid, idom, idvar, ix1, ix2, iy1, iy2, pv_r1d, pv_r2d, wpv_r3d )
+            ELSE
+               CALL iom_rstdimg_get( kiomid, idom, idvar, ix1, ix2, iy1, iy2, pv_r1d, pv_r2d )
+            ENDIF
+         CASE DEFAULT    
+            CALL ctl_stop( TRIM(clinfo)//' accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
+         END SELECT
+#else
          SELECT CASE (iom_file(kiomid)%iolib)
          CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, inbdim, istart, icnt, ix1, ix2, iy1, iy2,   &
@@ -730,9 +805,26 @@
             CALL ctl_stop( TRIM(clinfo)//' accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
          END SELECT
+#endif
+
+#if defined key_z_first
+         !! DCSE_NEMO: if necessary, copy 3d work array back into pv_r3d,
+         !!            and de-allocate the work array
+         IF (PRESENT(pv_r3d)) THEN
+            ! This assumes that pv_r3d is not ftransed
+            DO jk = 1, ishape_pv_r3d(3)
+               DO jj = 1, ishape_pv_r3d(2)
+                  DO ji = 1, ishape_pv_r3d(1)
+                     pv_r3d(jk, ji, jj) = wpv_r3d(ji, jj, jk)
+                  ENDDO
+               ENDDO
+            ENDDO
+            DEALLOCATE(wpv_r3d)
+         ENDIF
+#endif
 
          IF( istop == nstop ) THEN   ! no additional errors until this point...
             IF(lwp) WRITE(numout,"(10x,' read ',a,' (rec: ',i4,') in ',a,' ok')") TRIM(cdvar), itime, TRIM(iom_file(kiomid)%name)
           
-            !--- overlap areas and extra hallows (mpp)
+            !--- overlap areas and extra haloes (mpp)
             IF(     PRESENT(pv_r2d) .AND. idom /= jpdom_unknown ) THEN
                CALL lbc_lnk( pv_r2d,'Z',-999.,'no0' )
@@ -934,4 +1026,36 @@
       INTEGER         , INTENT(in), OPTIONAL               ::   ktype    ! variable external type
       INTEGER :: ivid   ! variable id
+#if defined key_z_first
+      !! DCSE_NEMO: Need to transpose the dimensions of pvar from internal to external orderings
+      !  We do not use ftrans here
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)              ::   pvar_trans    ! transposed pvar
+      INTEGER                                              ::   ji, jj, jk    ! Dummy loop indices
+      IF( kiomid > 0 ) THEN
+         IF( iom_file(kiomid)%nfid > 0 ) THEN
+            ivid = iom_varid( kiomid, cdvar, ldstop = .FALSE. )
+            IF (      (SIZE(pvar, DIM=1) /= jpk )   &
+               & .OR. (SIZE(pvar, DIM=2) /= jpi )   &
+               & .OR. (SIZE(pvar, DIM=3) /= jpj ) ) THEN
+               CALL ctl_stop( 'iom_rp3d: unexpected shape for variable ', cdvar )
+            END IF
+            ALLOCATE( pvar_trans(jpi, jpj, jpk) )
+            DO jk = 1, jpk
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     pvar_trans(ji, jj, jk) = pvar(jk, ji, jj)
+                  END DO
+               END DO
+            END DO
+            SELECT CASE (iom_file(kiomid)%iolib)
+            CASE (jpioipsl )   ;   CALL iom_ioipsl_rstput( kt, kwrite, kiomid, cdvar, ivid, ktype, pv_r3d = pvar_trans )
+            CASE (jpnf90   )   ;   CALL iom_nf90_rstput(   kt, kwrite, kiomid, cdvar, ivid, ktype, pv_r3d = pvar_trans )
+            CASE (jprstdimg)   ;   IF( kt == kwrite )   CALL iom_rstdimg_rstput( kiomid, cdvar, ivid, pv_r3d = pvar_trans )
+            CASE DEFAULT     
+               CALL ctl_stop( 'iom_rp3d: accepted IO library are only jpioipsl and jprstdimg' )
+            END SELECT
+            DEALLOCATE( pvar_trans )
+         ENDIF
+      ENDIF
+#else
       IF( kiomid > 0 ) THEN
          IF( iom_file(kiomid)%nfid > 0 ) THEN
@@ -946,4 +1070,5 @@
          ENDIF
       ENDIF
+#endif
    END SUBROUTINE iom_rp3d
 
@@ -976,5 +1101,12 @@
       REAL(wp),       DIMENSION(:,:,:), INTENT(in) ::   pfield3d
 #if defined key_iomput
+#if defined key_z_first
+!FTRANS ASSERT :z :I
+!FTRANS pfield3d :I :I :z
+      CALL event__write_field3D( cdname, permute_z_last(pfield3d(nldi:nlei, nldj:nlej, :)) )
+#else
+!FTRANS ASSERT :I :z
       CALL event__write_field3D( cdname, pfield3d(nldi:nlei, nldj:nlej, :) )
+#endif
 #else
       IF( .FALSE. )   WRITE(numout,*) cdname, pfield3d   ! useless test to avoid compilation warnings
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 3211)
@@ -35,4 +35,8 @@
       MODULE PROCEDURE iom_ioipsl_rp0123d
    END INTERFACE
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 3211)
@@ -40,4 +40,7 @@
       MODULE PROCEDURE iom_nf90_rp0123d
    END INTERFACE
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_rstdimg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_rstdimg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/iom_rstdimg.F90	(revision 3211)
@@ -34,4 +34,7 @@
 
    INTEGER, PARAMETER ::   jpvnl          = 32   ! variable name length
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
       
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90	(revision 3211)
@@ -28,4 +28,7 @@
    PUBLIC prt_ctl_info    ! called by all subroutines
    PUBLIC prt_ctl_init    ! called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -77,4 +80,11 @@
       USE wrk_nemo, ONLY:   zmask1   => wrk_3d_11 , zmask2   => wrk_3d_12 
       USE wrk_nemo, ONLY:   ztab3d_1 => wrk_3d_13 , ztab3d_2 => wrk_3d_14
+
+      !! DCSE_NEMO: Need additional directives for renamed module variables
+!FTRANS zmask1 zmask2 ztab3d_1 ztab3d_2 :I :I :z
+
+!FTRANS tab3d_1 mask1 :I :I :z
+!FTRANS tab3d_2 mask2 :I :I :z
+
       !
       REAL(wp), DIMENSION(:,:)  , INTENT(in), OPTIONAL ::   tab2d_1
@@ -120,4 +130,5 @@
       IF( PRESENT(tab2d_1) )   ztab2d_1(:,:)        = tab2d_1(:,:)
       IF( PRESENT(tab2d_2) )   ztab2d_2(:,:)        = tab2d_2(:,:)
+   !! DCSE_NEMO: attention!
       IF( PRESENT(tab3d_1) )   ztab3d_1(:,:,1:kdir) = tab3d_1(:,:,:)
       IF( PRESENT(tab3d_2) )   ztab3d_2(:,:,1:kdir) = tab3d_2(:,:,:)
@@ -209,4 +220,7 @@
    END SUBROUTINE prt_ctl
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
 
    SUBROUTINE prt_ctl_info (clinfo1, ivar1, clinfo2, ivar2, itime)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 3211)
@@ -35,4 +35,10 @@
    LOGICAL, PUBLIC ::   lrst_oce =  .FALSE.   !: logical to control the oce restart write 
    INTEGER, PUBLIC ::   numror, numrow        !: logical unit for cean restart (read and write)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trdmld_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/zpermute.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/zpermute.F90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/IOM/zpermute.F90	(revision 3211)
@@ -0,0 +1,91 @@
+MODULE zpermute
+   !!=====================================================================
+   !!                    ***  MODULE  zpermute ***
+   !! Manipulate array :  Library to read input files
+   !!====================================================================
+   !! History :  3.3.1  ! 2011 11  (S. Pickles) Original code
+   !!
+   !!--------------------------------------------------------------------
+   !!   permute_z_last : return pointer to a copy of an array with indices
+   !!                    permuted back to z_last ordering
+   !!--------------------------------------------------------------------
+   USE par_oce, ONLY : wp                   ! ocean parameters - working precision
+   USE lib_mpp, ONLY : ctl_warn, ctl_stop   ! warning and fatal messages
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC permute_z_last
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   FUNCTION permute_z_last( pain )   RESULT ( p_permuted )
+
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE permute_z_last  ***
+      !!
+      !! ** Purpose :   
+      !!
+      !!----------------------------------------------------------------------
+
+      REAL(wp), INTENT(in) :: pain(:,:,:)
+
+      REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET :: pain_reordered 
+      REAL(wp), POINTER, DIMENSION(:,:,:)                   :: p_permuted
+ 
+      INTEGER, SAVE :: jiss=-1, jjss=-1, jkss=-1
+      INTEGER       :: jisz,    jjsz,    jksz
+      INTEGER       :: ji,      jj,      jk
+      INTEGER       :: ifail
+
+#if defined key_z_first
+      jisz = SIZE(pain, DIM=2)
+      jjsz = SIZE(pain, DIM=3)
+      jksz = SIZE(pain, DIM=1)
+#else
+      jisz = SIZE(pain, DIM=1)
+      jjsz = SIZE(pain, DIM=2)
+      jksz = SIZE(pain, DIM=3)
+#endif
+
+      IF ( (jiss /= jisz) .OR. (jjss /= jjsz) .OR. (jkss /= jksz)) THEN
+         IF (ALLOCATED(pain_reordered)) THEN
+            DEALLOCATE(pain_reordered)
+         END IF 
+      ELSE
+         IF (.NOT. ALLOCATED(pain_reordered)) THEN
+            CALL ctl_warn("permute_z_last: unexpected need to allocate array")
+         END IF
+      END IF
+
+      IF (.NOT. ALLOCATED(pain_reordered)) THEN
+         ALLOCATE(pain_reordered(jisz,jjsz,jksz), STAT=ifail)
+         IF (ifail /= 0) THEN
+            CALL ctl_stop("permute_z_last: failure allocating output array")
+         END IF 
+      END IF
+
+      DO jk = 1, jksz
+         DO jj = 1, jjsz
+            DO ji = 1, jisz
+!FTRANS pain :I :I :z
+               pain_reordered(ji, jj, jk) = pain(ji, jj, jk)
+            END DO
+         END DO
+      END DO
+
+      jiss = jisz
+      jjss = jjsz
+      jkss = jksz
+      p_permuted => pain_reordered
+
+   END FUNCTION permute_z_last
+
+   !!======================================================================
+END MODULE zpermute
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/cla.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/cla.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/cla.F90	(revision 3211)
@@ -54,4 +54,9 @@
 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION (:) ::   t_171_94_hor, s_171_94_hor       ! Temperature, salinity in Hormuz strait
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
    
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lbclnk.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lbclnk.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lbclnk.F90	(revision 3211)
@@ -60,5 +60,9 @@
    PUBLIC   lbc_lnk       ! ocean/ice  lateral boundary conditions
    PUBLIC   lbc_lnk_e 
-   
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -81,6 +85,10 @@
       !!----------------------------------------------------------------------
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type1, cd_type2   ! nature of pt3d grid-points
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pt3d1   , pt3d2      ! 3D array on which the lbc is applied
-      REAL(wp)                        , INTENT(in   ) ::   psgn                 ! control of the sign 
+!FTRANS pt3d1 :I :I :z
+!FTRANS pt3d2 :I :I :z
+! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pt3d1   , pt3d2      ! 3D array on which the lbc is applied
+      REAL(wp), INTENT(inout)   ::   pt3d1(jpi,jpj,jpk)   , pt3d2(jpi,jpj,jpk)
+      REAL(wp), INTENT(in   )   ::   psgn                 ! control of the sign 
       !!----------------------------------------------------------------------
       !
@@ -104,5 +112,8 @@
       !!----------------------------------------------------------------------
       CHARACTER(len=1)                , INTENT(in   )           ::   cd_type   ! nature of pt3d grid-points
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)           ::   pt3d      ! 3D array on which the lbc is applied
+!FTRANS pt3d :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)           ::   pt3d      ! 3D array on which the lbc is applied
+      REAL(wp), INTENT(inout)                                   ::   pt3d(jpi,jpj,jpk)
       REAL(wp)                        , INTENT(in   )           ::   psgn      ! control of the sign 
       CHARACTER(len=3)                , INTENT(in   ), OPTIONAL ::   cd_mpp    ! MPP only (here do nothing)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lbcnfd.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lbcnfd.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lbcnfd.F90	(revision 3211)
@@ -24,4 +24,7 @@
    PUBLIC   lbc_nfd   ! north fold conditions
 
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -47,4 +50,5 @@
       !                                                        !   = -1. , the sign is changed if north fold boundary
       !                                                        !   =  1. , the sign is kept  if north fold boundary
+!FTRANS pt3d :I :I :z
       REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   pt3d      ! 3D array on which the boundary condition is applied
       !
@@ -59,5 +63,7 @@
       ijpjm1 = ijpj-1
 
+#if !defined key_z_first
       DO jk = 1, jpk
+#endif
          !
          SELECT CASE ( npolj )
@@ -69,30 +75,68 @@
                DO ji = 2, jpiglo
                   ijt = jpiglo-ji+2
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj,jk) = psgn * pt3d(ijt,ijpj-2,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj,jk) = psgn * pt3d(ijt,ijpj-2,jk)
+#endif
                END DO
                DO ji = jpiglo/2+1, jpiglo
                   ijt = jpiglo-ji+2
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpjm1,jk) = psgn * pt3d(ijt,ijpjm1,jk)
+                  END DO
+#else
                   pt3d(ji,ijpjm1,jk) = psgn * pt3d(ijt,ijpjm1,jk)
+#endif
                END DO
             CASE ( 'U' )                               ! U-point
                DO ji = 1, jpiglo-1
                   iju = jpiglo-ji+1
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj,jk) = psgn * pt3d(iju,ijpj-2,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj,jk) = psgn * pt3d(iju,ijpj-2,jk)
+#endif
                END DO
                DO ji = jpiglo/2, jpiglo-1
                   iju = jpiglo-ji+1
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpjm1,jk) = psgn * pt3d(iju,ijpjm1,jk)
+                  END DO
+#else
                   pt3d(ji,ijpjm1,jk) = psgn * pt3d(iju,ijpjm1,jk)
+#endif
                END DO
             CASE ( 'V' )                               ! V-point
                DO ji = 2, jpiglo
                   ijt = jpiglo-ji+2
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj-1,jk) = psgn * pt3d(ijt,ijpj-2,jk)
+                     pt3d(ji,ijpj  ,jk) = psgn * pt3d(ijt,ijpj-3,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj-1,jk) = psgn * pt3d(ijt,ijpj-2,jk)
                   pt3d(ji,ijpj  ,jk) = psgn * pt3d(ijt,ijpj-3,jk)
+#endif
                END DO
             CASE ( 'F' )                               ! F-point
                DO ji = 1, jpiglo-1
                   iju = jpiglo-ji+1
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj-1,jk) = psgn * pt3d(iju,ijpj-2,jk)
+                     pt3d(ji,ijpj  ,jk) = psgn * pt3d(iju,ijpj-3,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj-1,jk) = psgn * pt3d(iju,ijpj-2,jk)
                   pt3d(ji,ijpj  ,jk) = psgn * pt3d(iju,ijpj-3,jk)
+#endif
                END DO
             END SELECT
@@ -104,28 +148,64 @@
                DO ji = 1, jpiglo
                   ijt = jpiglo-ji+1
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj,jk) = psgn * pt3d(ijt,ijpj-1,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj,jk) = psgn * pt3d(ijt,ijpj-1,jk)
+#endif
                END DO
             CASE ( 'U' )                               ! U-point
                DO ji = 1, jpiglo-1
                   iju = jpiglo-ji
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj,jk) = psgn * pt3d(iju,ijpj-1,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj,jk) = psgn * pt3d(iju,ijpj-1,jk)
+#endif
                END DO
             CASE ( 'V' )                               ! V-point
                DO ji = 1, jpiglo
                   ijt = jpiglo-ji+1
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj,jk) = psgn * pt3d(ijt,ijpj-2,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj,jk) = psgn * pt3d(ijt,ijpj-2,jk)
+#endif
                END DO
                DO ji = jpiglo/2+1, jpiglo
                   ijt = jpiglo-ji+1
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpjm1,jk) = psgn * pt3d(ijt,ijpjm1,jk)
+                  END DO
+#else
                   pt3d(ji,ijpjm1,jk) = psgn * pt3d(ijt,ijpjm1,jk)
+#endif
                END DO
             CASE ( 'F' )                               ! F-point
                DO ji = 1, jpiglo-1
                   iju = jpiglo-ji
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpj  ,jk) = psgn * pt3d(iju,ijpj-2,jk)
+                  END DO
+#else
                   pt3d(ji,ijpj  ,jk) = psgn * pt3d(iju,ijpj-2,jk)
+#endif
                END DO
                DO ji = jpiglo/2+1, jpiglo-1
                   iju = jpiglo-ji
+#if defined key_z_first
+                  DO jk = 1, jpk
+                     pt3d(ji,ijpjm1,jk) = psgn * pt3d(iju,ijpjm1,jk)
+                  END DO
+#else
                   pt3d(ji,ijpjm1,jk) = psgn * pt3d(iju,ijpjm1,jk)
+#endif
                END DO
             END SELECT
@@ -135,13 +215,24 @@
             SELECT CASE ( cd_type)
             CASE ( 'T' , 'U' , 'V' , 'W' )             ! T-, U-, V-, W-points
+#if defined key_z_first
+               pt3d(:, 1  ,:) = 0.e0
+               pt3d(:,ijpj,:) = 0.e0
+#else
                pt3d(:, 1  ,jk) = 0.e0
                pt3d(:,ijpj,jk) = 0.e0
+#endif
             CASE ( 'F' )                               ! F-point
+#if defined key_z_first
+               pt3d(:,ijpj,:) = 0.e0
+#else
                pt3d(:,ijpj,jk) = 0.e0
+#endif
             END SELECT
             !
          END SELECT     !  npolj
          !
+#if !defined key_z_first
       END DO
+#endif
       !
    END SUBROUTINE lbc_nfd_3d
